var OAuthSimple;if(OAuthSimple===undefined){OAuthSimple=function(a,b){this._secrets={};this._parameters={};if(a!==undefined){this._secrets.consumer_key=a}if(b!==undefined){this._secrets.shared_secret=b}this._default_signature_method="HMAC-SHA1";this._action="GET";this._nonce_chars="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";this.reset=function(){this._parameters={};this._path=undefined;return this};this.setParameters=function(c){if(c===undefined){c={}}if(typeof(c)=="string"){c=this._parseParameterString(c)}this._parameters=c;if(this._parameters.oauth_nonce===undefined){this._getNonce()}if(this._parameters.oauth_timestamp===undefined){this._getTimestamp()}if(this._parameters.oauth_method===undefined){this.setSignatureMethod()}if(this._parameters.oauth_consumer_key===undefined){this._getApiKey()}if(this._parameters.oauth_token===undefined){this._getAccessToken()}return this};this.setQueryString=function(c){return this.setParameters(c)};this.setURL=function(c){if(c==""){throw ("No path specified for OAuthSimple.setURL")}this._path=c;return this};this.setPath=function(c){return this.setURL(c)};this.setAction=function(c){if(c===undefined){c="GET"}c=c.toUpperCase();if(c.match("[^A-Z]")){throw ("Invalid action specified for OAuthSimple.setAction")}this._action=c;return this};this.setTokensAndSecrets=function(d){if(d){for(var c in d){this._secrets[c]=d[c]}}if(this._secrets.api_key){this._secrets.consumer_key=this._secrets.api_key}if(this._secrets.access_token){this._secrets.oauth_token=this._secrets.access_token}if(this._secrets.access_secret){this._secrets.oauth_secret=this._secrets.access_secret}if(this._secrets.consumer_key===undefined){throw ("Missing required consumer_key in OAuthSimple.setTokensAndSecrets")}if(this._secrets.shared_secret===undefined){throw ("Missing required shared_secret in OAuthSimple.setTokensAndSecrets")}if((this._secrets.oauth_token!==undefined)&&(this._secrets.oauth_secret===undefined)){throw ("Missing oauth_secret for supplied oauth_token in OAuthSimple.setTokensAndSecrets")}return this};this.setSignatureMethod=function(c){if(c===undefined){c=this._default_signature_method}if(c.toUpperCase().match(/(PLAINTEXT|HMAC-SHA1)/)===undefined){throw ("Unknown signing method specified for OAuthSimple.setSignatureMethod")}this._parameters.oauth_signature_method=c.toUpperCase();return this};this.sign=function(d){if(d===undefined){d={}}if(d.action!==undefined){this.setAction(d.action)}if(d.path!==undefined){this.setPath(d.path)}if(d.method!==undefined){this.setSignatureMethod(d.method)}this.setTokensAndSecrets(d.signatures);if(d.parameters!==undefined){this.setParameters(d.parameters)}var c=this._normalizedParameters();this._parameters.oauth_signature=this._generateSignature(c);return{parameters:this._parameters,signature:this._oauthEscape(this._parameters.oauth_signature),signed_url:this._path+"?"+this._normalizedParameters(),header:this.getHeaderString()}};this.getHeaderString=function(g){if(this._parameters.oauth_signature===undefined){this.sign(g)}var c="OAuth ";for(var d in this._parameters){if(!d.match(/^oauth/)){continue}if((this._parameters[d]) instanceof Array){var e=this._parameters[d].length;for(var f=0;f<e;f++){c+=d+'="'+this._oauthEscape(this._parameters[d][f])+'" '}}else{c+=d+'="'+this._oauthEscape(this._parameters[d])+'" '}}return c};this._parseParameterString=function(h){var g=h.split("&");var c={};for(var d=g.shift();d;d=g.shift()){var e=d.split("=");var f="";if(e[1]){f=decodeURIComponent(e[1])}if(c[e[0]]){if(!(c[e[0]] instanceof Array)){c[e[0]]=Array(c[e[0]],f)}else{c[e[0]].push(f)}}else{c[e[0]]=f}}return c};this._oauthEscape=function(c){if(c===undefined){return""}if(c instanceof Array){throw ("Array passed to _oauthEscape")}return encodeURIComponent(c).replace(/\!/g,"%21").replace(/\*/g,"%2A").replace(/'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29")};this._getNonce=function(f){if(f===undefined){f=5}var c="";var g=this._nonce_chars.length;for(var e=0;e<f;e++){var d=Math.floor(Math.random()*g);c+=this._nonce_chars.substring(d,d+1)}this._parameters.oauth_nonce=c;return c};this._getApiKey=function(){if(this._secrets.consumer_key===undefined){throw ("No consumer_key set for OAuthSimple.")}this._parameters.oauth_consumer_key=this._secrets.consumer_key;return this._parameters.oauth_consumer_key};this._getAccessToken=function(){if(this._secrets.oauth_secret===undefined){return""}if(this._secrets.oauth_token===undefined){throw ("No oauth_token (access_token) set for OAuthSimple.")}this._parameters.oauth_token=this._secrets.oauth_token;return this._parameters.oauth_token};this._getTimestamp=function(){var e=new Date();var c=Math.floor(e.getTime()/1000);this._parameters.oauth_timestamp=c;return c};this.b64_hmac_sha1=function(g,l,c,m){if(!c){c="="}if(!m){m=8}function i(r,k,u,s){if(r<20){return(k&u)|((~k)&s)}if(r<40){return k^u^s}if(r<60){return(k&u)|(k&s)|(u&s)}return k^u^s}function f(d){return(d<20)?1518500249:(d<40)?1859775393:(d<60)?-1894007588:-899497514}function p(k,s){var r=(k&65535)+(s&65535),d=(k>>16)+(s>>16)+(r>>16);return(d<<16)|(r&65535)}function q(k,d){return(k<<d)|(k>>>(32-d))}function j(H,z){H[z>>5]|=128<<(24-z%32);H[((z+64>>9)<<4)+15]=z;var I=[80],G=1732584193,F=-271733879,E=-1732584194,D=271733878,C=-1009589776;for(var B=0;B<H.length;B+=16){var y=G,v=F,u=E,k=D,K=C;for(var A=0;A<80;A++){if(A<16){I[A]=H[B+A]}else{I[A]=q(I[A-3]^I[A-8]^I[A-14]^I[A-16],1)}var J=p(p(q(G,5),i(A,F,E,D)),p(p(C,I[A]),f(A)));C=D;D=E;E=q(F,30);F=G;G=J}G=p(G,y);F=p(F,v);E=p(E,u);D=p(D,k);C=p(C,K)}return[G,F,E,D,C]}function n(t){var k=[],d=(1<<m)-1;for(var r=0;r<t.length*m;r+=m){k[r>>5]|=(t.charCodeAt(r/8)&d)<<(32-m-r%32)}return k}function h(s,x){var r=n(s);if(r.length>16){r=j(r,s.length*m)}var v=[16],w=[16];for(var t=0;t<16;t++){v[t]=r[t]^909522486;w[t]=r[t]^1549556828}var u=j(v.concat(n(x)),512+x.length*m);return j(w.concat(u),512+160)}function e(d){var v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="";for(var u=0;u<d.length*4;u+=3){var x=(((d[u>>2]>>8*(3-u%4))&255)<<16)|(((d[u+1>>2]>>8*(3-(u+1)%4))&255)<<8)|((d[u+2>>2]>>8*(3-(u+2)%4))&255);for(var k=0;k<4;k++){if(u*8+k*6>d.length*32){w+=c}else{w+=v.charAt((x>>6*(3-k))&63)}}}return w}function o(r,s){return e(h(r,s))}return o(g,l)};this._normalizedParameters=function(){var f=new Array();var l=[];var k=0;for(var g in this._parameters){if(k++>1000){throw ("runaway 1")}l.unshift(g)}l=l.sort();pLen=l.length;for(var e=0;e<pLen;e++){g=l[e];if(g.match(/\w+_secret/)){continue}if(this._parameters[g] instanceof Array){var c=this._parameters[g].sort();var h=c.length;for(var d=0;d<h;d++){if(k++>1000){throw ("runaway 1")}f.push(this._oauthEscape(g)+"="+this._oauthEscape(c[d]))}continue}f.push(this._oauthEscape(g)+"="+this._oauthEscape(this._parameters[g]))}return f.join("&")};this._generateSignature=function(){var c=this._oauthEscape(this._secrets.shared_secret)+"&"+this._oauthEscape(this._secrets.oauth_secret);if(this._parameters.oauth_signature_method=="PLAINTEXT"){return c}if(this._parameters.oauth_signature_method=="HMAC-SHA1"){var d=this._oauthEscape(this._action)+"&"+this._oauthEscape(this._path)+"&"+this._oauthEscape(this._normalizedParameters());return this.b64_hmac_sha1(c,d)}return null};return this}}function ChromeExOAuth(g,e,d,c,a,b,f){this.url_request_token=g;this.url_auth_token=e;this.url_access_token=d;this.consumer_key=c;this.consumer_secret=a;this.oauth_scope=b;this.app_name=f&&f.app_name||"ChromeExOAuth Library";this.key_token="oauth_token";this.key_token_secret="oauth_token_secret";this.callback_page=f&&f.callback_page||"chrome_ex_oauth.html";this.auth_params={};if(f&&f.auth_params){for(key in f.auth_params){if(f.auth_params.hasOwnProperty(key)){this.auth_params[key]=f.auth_params[key]}}}}ChromeExOAuth.initBackgroundPage=function(a){window.chromeExOAuthConfig=a;window.chromeExOAuth=ChromeExOAuth.fromConfig(a);window.chromeExOAuthRedirectStarted=false;window.chromeExOAuthRequestingAccess=false;return window.chromeExOAuth};ChromeExOAuth.prototype.authorize=function(b){if(this.hasToken()){b(this.getToken(),this.getTokenSecret())}else{window.chromeExOAuthOnAuthorize=function(d,c){b(d,c)};var a=chrome.extension.getURL(this.callback_page);proc_newwindow({url:a},null,true)}};ChromeExOAuth.prototype.clearTokens=function(){delete localStorage[this.key_token+encodeURI(this.oauth_scope)];delete localStorage[this.key_token_secret+encodeURI(this.oauth_scope)]};ChromeExOAuth.prototype.hasToken=function(){return !!this.getToken()};ChromeExOAuth.prototype.sendSignedRequest=function(b,h,c){var g=c&&c.method||"GET";var a=c&&c.body||null;var f=c&&c.parameters||{};var e=c&&c.headers||{};var d=this.signURL(b,g,f);ChromeExOAuth.sendRequest(g,d,e,a,function(i){if(i.readyState==4){h(i.responseText,i)}})};ChromeExOAuth.prototype.signURL=function(c,g,e){var d=this.getToken();var b=this.getTokenSecret();if(!d||!b){throw new Error("No oauth token or token secret")}var f=e||{};var a=OAuthSimple().sign({action:g,path:c,parameters:f,signatures:{consumer_key:this.consumer_key,shared_secret:this.consumer_secret,oauth_secret:b,oauth_token:d}});return a.signed_url};ChromeExOAuth.prototype.getAuthorizationHeader=function(b,f,d){var c=this.getToken();var a=this.getTokenSecret();if(!c||!a){throw new Error("No oauth token or token secret")}var e=d||{};return OAuthSimple().getHeaderString({action:f,path:b,parameters:e,signatures:{consumer_key:this.consumer_key,shared_secret:this.consumer_secret,oauth_secret:a,oauth_token:c}})};ChromeExOAuth.fromConfig=function(a){return new ChromeExOAuth(a.request_url,a.authorize_url,a.access_url,a.consumer_key,a.consumer_secret,a.scope,{app_name:a.app_name,auth_params:a.auth_params})};ChromeExOAuth.initCallbackPage=function(){var c=chrome.extension.getBackgroundPage();var b=c.chromeExOAuthConfig;var a=ChromeExOAuth.fromConfig(b);c.chromeExOAuthRedirectStarted=true;a.initOAuthFlow(function(e,d){c.chromeExOAuthOnAuthorize(e,d);c.chromeExOAuthRedirectStarted=false;chrome.tabs.getSelected(null,function(f){chrome.tabs.remove(f.id)})})};ChromeExOAuth.sendRequest=function(g,b,d,a,f){var c=new XMLHttpRequest();c.onreadystatechange=function(h){f(c,h)};c.open(g,b,true);if(d){for(var e in d){if(d.hasOwnProperty(e)){c.setRequestHeader(e,d[e])}}}c.send(a)};ChromeExOAuth.formDecode=function(e){var h=e.split("&");var a={};for(var d=0,g;g=h[d];d++){var c=g.split("=");if(c.length==2){var b=ChromeExOAuth.fromRfc3986(c[0]);var f=ChromeExOAuth.fromRfc3986(c[1]);a[b]=f}}return a};ChromeExOAuth.getQueryStringParams=function(){var b=window.location.href.split("?");if(b.length>=2){var a=b.slice(1).join("?");return ChromeExOAuth.formDecode(a)}return{}};ChromeExOAuth.bind=function(b,c){var a=Array.prototype.slice.call(arguments).slice(2);return function(){var d=a.concat(Array.prototype.slice.call(arguments));b.apply(c,d)}};ChromeExOAuth.toRfc3986=function(a){return encodeURIComponent(a).replace(/\!/g,"%21").replace(/\*/g,"%2A").replace(/'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29")};ChromeExOAuth.fromRfc3986=function(b){var a=b.replace(/%21/g,"!").replace(/%2A/g,"*").replace(/%27/g,"'").replace(/%28/g,"(").replace(/%29/g,")");return decodeURIComponent(a)};ChromeExOAuth.addURLParam=function(b,c,d){var a=(b.indexOf("?")>=0)?"&":"?";return b+a+ChromeExOAuth.toRfc3986(c)+"="+ChromeExOAuth.toRfc3986(d)};ChromeExOAuth.prototype.setToken=function(a){localStorage[this.key_token+encodeURI(this.oauth_scope)]=a};ChromeExOAuth.prototype.getToken=function(){return localStorage[this.key_token+encodeURI(this.oauth_scope)]};ChromeExOAuth.prototype.setTokenSecret=function(a){localStorage[this.key_token_secret+encodeURI(this.oauth_scope)]=a};ChromeExOAuth.prototype.getTokenSecret=function(){return localStorage[this.key_token_secret+encodeURI(this.oauth_scope)]};ChromeExOAuth.prototype.initOAuthFlow=function(e){if(!this.hasToken()){var d=ChromeExOAuth.getQueryStringParams();if(d.chromeexoauthcallback=="true"){var a=d.oauth_token;var c=d.oauth_verifier;this.getAccessToken(a,c,e)}else{var b={url_callback_param:"chromeexoauthcallback"};this.getRequestToken(function(f){window.location.href=f},b)}}else{e(this.getToken(),this.getTokenSecret())}};ChromeExOAuth.prototype.getRequestToken=function(g,e){if(typeof g!=="function"){throw new Error("Specified callback must be a function.")}var b=e&&e.url_callback||window&&window.top&&window.top.location&&window.top.location.href;var f=e&&e.url_callback_param||"chromeexoauthcallback";var c=ChromeExOAuth.addURLParam(b,f,"true");var a=OAuthSimple().sign({path:this.url_request_token,parameters:{xoauth_displayname:this.app_name,scope:this.oauth_scope,oauth_callback:c},signatures:{consumer_key:this.consumer_key,shared_secret:this.consumer_secret}});var d=ChromeExOAuth.bind(this.onRequestToken,this,g);ChromeExOAuth.sendRequest("GET",a.signed_url,null,null,d)};ChromeExOAuth.prototype.onRequestToken=function(f,e){if(e.readyState==4){if(e.status==200){var d=ChromeExOAuth.formDecode(e.responseText);var c=d.oauth_token;this.setTokenSecret(d.oauth_token_secret);var a=ChromeExOAuth.addURLParam(this.url_auth_token,"oauth_token",c);for(var b in this.auth_params){if(this.auth_params.hasOwnProperty(b)){a=ChromeExOAuth.addURLParam(a,b,this.auth_params[b])}}f(a)}else{throw new Error("Fetching request token failed. Status "+e.status)}}};ChromeExOAuth.prototype.getAccessToken=function(b,c,f){if(typeof f!=="function"){throw new Error("Specified callback must be a function.")}var d=chrome.extension.getBackgroundPage();if(d.chromeExOAuthRequestingAccess==false){d.chromeExOAuthRequestingAccess=true;var a=OAuthSimple().sign({path:this.url_access_token,parameters:{oauth_token:b,oauth_verifier:c},signatures:{consumer_key:this.consumer_key,shared_secret:this.consumer_secret,oauth_secret:this.getTokenSecret(this.oauth_scope)}});var e=ChromeExOAuth.bind(this.onAccessToken,this,f);ChromeExOAuth.sendRequest("GET",a.signed_url,null,null,e)}};ChromeExOAuth.prototype.onAccessToken=function(f,e){if(e.readyState==4){var c=chrome.extension.getBackgroundPage();if(e.status==200){var d=ChromeExOAuth.formDecode(e.responseText);var b=d.oauth_token;var a=d.oauth_token_secret;this.setToken(b);this.setTokenSecret(a);c.chromeExOAuthRequestingAccess=false;f(b,a)}else{c.chromeExOAuthRequestingAccess=false;throw new Error("Fetching access token failed with status "+e.status)}}};var gdoc_confg_title="Chrome_Pig_configuration_0.2";var gdoc_confg_content="";var gdoc_confg_action="";var gdoc_slient=false;var gdoc_docs=[];var util={};var gdocs={};var DEFAULT_MIMETYPES={atom:"application/atom+xml",document:"text/plain",spreadsheet:"text/csv",presentation:"text/plain",pdf:"application/pdf"};util.unstringify=function(b){var c=b.split("&");var f={};for(var a=0,e;e=c[a];++a){var d=e.split("=");f[decodeURIComponent(d[0])]=decodeURIComponent(d[1])}return f};util.fetchRemote=function(a,c){var b=new XMLHttpRequest();b.open("GET",a,true);b.send();b.onreadystatechange=function(){if(b.readyState==4){var d=b.responseText;c(d)}}};gdocs.getLink=function(b,a){for(var c=0,d;d=b[c];++c){if(d.rel===a){return d}}return null};gdocs.handleError=function(c,d){if(bgmodule){gdoc_btn_disable(false)}if(!gdoc_slient){var b=getValue(d,"<title>","</title>");var a=_i18n("msg_error")+"\n"+_i18n("msg_loginagain");if(b!=""){a=a+"\n\n"+b}alert(a);gdoc_logout()}else{oauth.clearTokens()}};gdocs.getCategory=function(c,b,e){for(var d=0,a;a=c[d];++d){if(e){if(a.scheme===b&&e===a.term){return a}}else{if(a.scheme===b){return a}}}return null};gdocs.constructAtomXml_=function(c,f,a){var e=a||null;var d=['<category scheme="http://schemas.google.com/g/2005/labels" ','term="http://schemas.google.com/g/2005/labels#starred" ','label="starred"/>'].join("");var b=["<?xml version='1.0' encoding='UTF-8'?>",'<entry xmlns="http://www.w3.org/2005/Atom">','<category scheme="http://schemas.google.com/g/2005#kind"',' term="http://schemas.google.com/docs/2007#',f,'"/>',e?d:"","<title>",c,"</title>","</entry>"].join("");return b};gdocs.constructContentBody_=function(c,e,a,d,b){var a=["--END_OF_PART\r\n","Content-Type: application/atom+xml;\r\n\r\n",gdocs.constructAtomXml_(c,e,b),"\r\n","--END_OF_PART\r\n","Content-Type: ",d,"\r\n\r\n",a,"\r\n","--END_OF_PART--\r\n"].join("");return a};gdocs.processDocListResults=function(d,l){if(l.status!=200){gdocs.handleError(l,d);return}else{}var e=JSON.parse(d);var g="";var b="";try{g=e.feed.author[0].email.$t}catch(c){}var h="";if(e.feed.entry){for(var f=0,k;k=e.feed.entry[f];++f){h=k.title.$t;if(h==gdoc_confg_title){var a={};a.title=h;a.email=k.author[0].email.$t;g=a.email;b=k.updated.$t;if(k.app$edited&&k.app$edited.$t>b){b=k.app$edited.$t}a.resourceId=k.gd$resourceId.$t;a.type=gdocs.getCategory(k.category,"http://schemas.google.com/g/2005#kind");a.contentSrc=k.content.src;gdoc_docs.push(a);break}}}if(g!=""){localStorage.gdoc_last_email=g;if(bgmodule){gdoc_status()}}var j=false;if(e.feed.link){j=gdocs.getLink(e.feed.link,"next")}if((gdoc_docs.length==0)&&(j)&&(j.href)){gdocs.getDocumentList(j.href)}else{if(gdoc_confg_action=="load"){if(gdoc_docs.length>0){gdocs.loadDocument(b)}else{if(bgmodule){gdoc_btn_disable(false)}if(g==""){localStorage.gdoc_last_email="User ID is not confirmed yet.";if(bgmodule){gdoc_status()}}if(!gdoc_slient){alert(safegetlang("msg_savenewone","Can not find saved configuration data in Google Drive.\nSave new one to Google Drive."))}}}else{if(gdoc_confg_action=="save"){gdocs.saveDocument()}else{if(gdoc_confg_action=="login"){if(bgmodule){gdoc_btn_disable(false)}}}}}};gdocs.loadDocument=function(c){var a=gdoc_docs[0];var b=a.contentSrc+"&exportformat=txt&format=txt";util.fetchRemote(b,function(h){var k=h;if(k==null){k=""}k=trim(k);if(bgmodule){gdoc_btn_disable(false)}var i=false;if(k.indexOf("[{")==0||k.indexOf("Data:")==0){i=true}if(i){if(!gdoc_slient){var l="";if(c!=""){var d=(new Date()).setISO8601(c);var e=d.getHours();var f=d.getMinutes();datetime=((e<10)?"0":"")+e+":"+((f<10)?"0":"")+f;l=d.getFullYear()+"-"+fillnumber(d.getMonth()+1)+"-"+fillnumber(d.getDate())+" "+datetime}var g=document.getElementById("storage_data_area");if(k.indexOf("Data:")==0){k=k.substr(7,k.length)}g.value=k;var j=chrome.i18n.getMessage("msg_importsuccess");if(l!=""){j+="\n\n"+safegetlang("msg_savedtime","Saved time")+": "+l}alert(j)}}else{if(!gdoc_slient){alert(chrome.i18n.getMessage("msg_error")+"\n"+safegetlang("msg_wrongdata","Wrong data or You have already logged out.\nPlease login again, and Retry."));gdoc_logout()}}})};gdocs.saveDocument=function(){if(gdoc_docs.length==0){gdocs.createDoc()}else{gdocs.updateDoc(gdoc_docs[0])}};gdocs.createDoc=function(){var e=gdoc_confg_title;var b=gdoc_confg_content;gdoc_confg_content="";var d=false;var f="document";var a=function(i,h){var g=new Date();localStorage.gdoc_lastsavetime=g.getTime();if(bgmodule){gdoc_btn_disable(false)}gdoc_confg_action="login";gdoc_docs=[];if(bgmodule){bgmodule.oauth.authorize(function(){gdocs.getDocumentList()})}else{oauth.authorize(function(){gdocs.getDocumentList()})}if(!gdoc_slient){alert(chrome.i18n.getMessage("conf_saved"))}};var c={method:"POST",headers:{"GData-Version":"3.0","Content-Type":"multipart/related; boundary=END_OF_PART",},parameters:{alt:"json"},body:gdocs.constructContentBody_(e,f,b,DEFAULT_MIMETYPES[f],d)};if(bgmodule){bgmodule.oauth.sendSignedRequest(bgmodule.DOCLIST_FEED,a,c)}else{oauth.sendSignedRequest(DOCLIST_FEED,a,c)}};gdocs.updateDoc=function(b){var a=function(g){var f=new Date();localStorage.gdoc_lastsavetime=f.getTime();if(bgmodule){gdoc_btn_disable(false)}if(!gdoc_slient){alert(chrome.i18n.getMessage("conf_saved"))}};var d=gdoc_confg_content;gdoc_confg_content="";var e={method:"PUT",headers:{"GData-Version":"3.0","Content-Type":DEFAULT_MIMETYPES[b.type.label],"If-Match":"*",Slug:b.title},parameters:{alt:"json"},body:d};if(bgmodule){var c=bgmodule.DOCLIST_SCOPE+"/default/media/"+b.resourceId;bgmodule.oauth.sendSignedRequest(c,a,e)}else{var c=DOCLIST_SCOPE+"/default/media/"+b.resourceId;oauth.sendSignedRequest(c,a,e)}};gdocs.getDocumentList=function(a){var b=a||null;var d={headers:{"GData-Version":"3.0"}};if(!b){if(bgmodule){b=bgmodule.DOCLIST_FEED}else{b=DOCLIST_FEED}d.parameters={alt:"json",showfolders:"true"}}else{var c=b.split("?");if(c.length>1){b=c[0];d.parameters=util.unstringify(c[1])}}if(bgmodule){bgmodule.oauth.sendSignedRequest(b,gdocs.processDocListResults,d)}else{oauth.sendSignedRequest(b,gdocs.processDocListResults,d)}};function proc_poponoption(p,c,v){try{function f(z,a){var A=localStorage[z];if((A==null)||isNaN(parseInt(A))||(A=="undefined")||(A=="null")){return a}else{return parseInt(A)}}var y="open_n"+p;var i=localStorage[y+"_url"];if(!i){return 1}var r=f(y+"_lasttime",0);var u=f(y+"_period",6);var h=f(y+"_pos",2);var q=f(y+"_width",300);var o=f(y+"_height",400);var m=f(y+"_topmost",1);var k=f(y+"_isfocus",1);var n=f(y+"_isstay",0);var s=f(y+"_otype",0);var l=f(y+"_wincheck",1);var d=f(y+"_last",0);var g=f(y+"_winok",0);var b=new Date();if(r>0){if((b.getTime()-r)/1000/60/60<u){return 1}localStorage[y+"_lasttime"]=b.getTime()}else{localStorage[y+"_lasttime"]=b.getTime();return 1}if(g==1&&navigator.userAgent.toLowerCase().indexOf("windows")<0){return}var j;if(c){j=c.isfail_npapi}else{j=isfail_npapi}if(s!=0){chrome.tabs.query({windowId:chrome.windows.WINDOW_ID_CURRENT},function(z){if(z.length==0){return}var A;for(var a=0;a<z.length;a++){if(z[a].active){A=z[a]}if(z[a].url.indexOf(i)==0){return}}if(!A){return}var B=true;if(k==1){B=false}if(!B){if(c){c.forcefrontnewtab_disable=true}else{forcefrontnewtab_disable=true}}if(d==1){chrome.tabs.create({url:i,selected:B})}else{if(B&&!A.incognito){window.open(i)}else{chrome.tabs.create({url:i,selected:B,index:A.index+1})}}});return}if(c){var x=c.get_popup_position(q,o,h);var t=c.lastpopwindowid}else{var x=get_popup_position(q,o,h);var t=lastpopwindowid}if(j&&u==0){return}function w(){if(j){chrome.tabs.query({active:true,windowId:chrome.windows.WINDOW_ID_CURRENT},function(a){if(a.length==0){return}var z=a[0];if(c){c.forcefrontnewtab_disable=true}else{forcefrontnewtab_disable=true}if(d==1){chrome.tabs.create({url:i,selected:false})}else{chrome.tabs.create({url:i,selected:false,index:z.index+1})}});return}chrome.windows.create({url:i,left:x.left,top:x.top,width:x.width,height:x.height,type:"popup"},function(z){if(c){c.lastpopwindowid=z.id}else{lastpopwindowid=z.id}if(m==1){chrome.windows.update(z.id,{focused:true},function(B){if(c){var A=c.proc_alwaystop("1",1)}else{var A=proc_alwaystop("1",1)}if(A&&(k==1)&&v){chrome.tabs.update(v,{selected:true})}})}if(c&&n==1&&v){var a=z.id;setInterval(function(){chrome.windows.get(a,{},function(A){if(!A){chrome.tabs.remove(v)}})},1000)}})}if(l==1&&t){chrome.windows.get(t,{},function(a){if(a){if(c&&n==1&&v){setInterval(function(){chrome.windows.get(t,{},function(z){if(!z){chrome.tabs.remove(v)}})},1000)}}else{w()}})}else{w()}}catch(e){}};